import java.util.Deque;
import java.util.LinkedList;

import aiinterface.AIInterface;
import aiinterface.CommandCenter;
import data.GlobalConstants;
import enumerate.Action;
import filter.ActionFilter;
import processors.ActionDecider;
import simulator.Simulator;
import struct.AttackData;
import struct.FrameData;
import struct.GameData;
import struct.Key;

public class Tomatensimulator implements AIInterface {

	private boolean playerNumber;
	private String myCharacter = "unknown";

	private ActionDecider decider;
	private String nextCommand = "STAND";
	private FrameData frameData;

	private GameData game;
	private struct.Key inKey;
	private CommandCenter cc;
	private Simulator sim;

	private String currentCommand = "";


	public void close()
	{
	}

	@Override
	public void roundEnd(int p1Hp, int p2Hp, int frames){

	}

	public void getInformation(FrameData arg0)
	{
		//game still initializing
		if(arg0.getEmptyFlag())
			return;

		Deque<Action> myQueue = new LinkedList<Action>();
		Deque<Action> opQueue = new LinkedList<Action>();
		myQueue.add(arg0.getCharacter(playerNumber).getAction());
		opQueue.add(arg0.getCharacter(!playerNumber).getAction());

		myQueue.add(arg0.getCharacter(playerNumber).getAction());
		opQueue.add(arg0.getCharacter(!playerNumber).getAction());

		myQueue.add(arg0.getCharacter(playerNumber).getAction());
		opQueue.add(arg0.getCharacter(!playerNumber).getAction());

		myQueue.add(arg0.getCharacter(playerNumber).getAction());
		opQueue.add(arg0.getCharacter(!playerNumber).getAction());

		myQueue.add(arg0.getCharacter(playerNumber).getAction());
		opQueue.add(arg0.getCharacter(!playerNumber).getAction());

		myQueue.add(arg0.getCharacter(playerNumber).getAction());
		opQueue.add(arg0.getCharacter(!playerNumber).getAction());


		myQueue.add(arg0.getCharacter(playerNumber).getAction());
		opQueue.add(arg0.getCharacter(!playerNumber).getAction());

		FrameData simData = sim.simulate(arg0, this.playerNumber, myQueue, opQueue, 15);
		ActionFilter.simMyData = simData.getCharacter(playerNumber);
		ActionFilter.simOpData = simData.getCharacter(!playerNumber);

		Deque<AttackData> attacks = new LinkedList<AttackData>();
		for ( AttackData a: simData.getProjectiles()){
			if(this.playerNumber != a.isPlayerNumber())
			{
				attacks.addLast(a);
			}
		}

		ActionFilter.simProj = attacks;


		ActionFilter.updateMotionInformation(arg0, playerNumber);
		this.cc.setFrameData(arg0, playerNumber);
		this.frameData = arg0;
		nextCommand = this.decider.findBestAction(arg0.getCharacter(playerNumber), arg0.getCharacter(!playerNumber), arg0);
	}

	public int initialize(GameData arg0, boolean arg1)
	{
		this.game = arg0;
		this.playerNumber = arg1;
		this.myCharacter = arg0.getCharacterName(this.playerNumber);
		this.frameData = new FrameData();
		this.inKey = new Key();
		this.decider = new ActionDecider(this.game.getMotionData(arg1), this.game, this.playerNumber);
		this.cc = new CommandCenter();
		this.sim = new Simulator(arg0);
		GlobalConstants.stageMaxX = arg0.getStageWidth();
		GlobalConstants.stageMaxY = arg0.getStageHeight();


		return 0;
	}



	int tmp = 0;
	public Key input()
	{
		return inKey;
	}

	public void processing()
	{
		if(!frameData.getEmptyFlag() && frameData.getRemainingTime() > 0)
		{
			if(this.cc.getSkillFlag())
			{
				Key k = cc.getSkillKey();
				guardWorkaround(k);
			}
			else
			{
				cc.skillCancel();
				cc.commandCall(nextCommand);
				currentCommand = nextCommand;
			}
		}
	}

	private void guardWorkaround(Key k)
	{
		if (currentCommand.contains("GUARD") && noneKey(k))
			return;
		else
			this.inKey = k;

	}

	private boolean noneKey(Key k)
	{
		return !(k.A || k.B || k.C || k.D || k.L || k.R || k.U);
	}

}
