import aiinterface.CommandCenter;
import struct.FrameData;
import struct.GameData;
import struct.Key;

public class Rule_FAR_Proj implements RuleLine {

	private int priority = 3;
	private int weight = 10;
	private boolean activated = false;

	private final int MAX_DURATION = 31;
	private int duration = 0;

	public String getStr(){
		return "Far_Projectile("+priority+","+weight+","+activated+")";
	}



	@Override
	public int getWeight() {
		return weight;
	}

	@Override
	public void setWeight(int w) {
		this.weight = w;
	}

	@Override
	public int getPriority() {
		return priority;
	}


	@Override
	public boolean getActivated() {
		return activated;
	}

	@Override
	public void setActivated(boolean activated_) {
		this.activated = activated_;
	}


	@Override
	public boolean checkCondition(GameData gd, FrameData fd, CommandCenter cc) {
		// TODO Auto-generated method stub
		int distX =  fd.getDistanceX();
		return (distX >= CNSTs.FAR_DIST_MIN);
	}

	@Override
	public void preset(GameData gd, FrameData fd, CommandCenter cc) {
		duration = 0;
		cc.skillCancel();
	}

	@Override
	public boolean hasActionEnded(GameData gd, FrameData fd, CommandCenter cc) {
		// TODO Auto-generated method stub
		if(duration==MAX_DURATION){
			return true;
		}
		return false;
	}

	@Override
	public Key exeAction(CommandCenter cc, FrameData fd) {
		duration++;
		if(cc.getSkillFlag()){
			return cc.getSkillKey();
		}
		if(fd.getCharacter(BANZAI.PLAYER_NUMBER).getEnergy()>=30){
			cc.commandCall("2 3 6 _ B");
		} else {
			cc.commandCall("2 3 6 _ A");
		}
		Key key = cc.getSkillKey();
		return key;

	}
}
